﻿using System;
using System.Collections.Generic;

namespace CShp_Listas
{

    public class Pessoa
    {
        public Pessoa() { }

        public string Nome { get; set; }
        public int Idade { get; set; }
        public Pessoa(int idade, string nome)
        {
            this.Idade = idade;
            this.Nome = nome;
        }
    }

    class Program
    {
        static List<Pessoa> pessoas;

        static void Main(string[] args)
        {
            pessoas = new List<Pessoa>();

            pessoas.Add(new Pessoa(50, "Macoratti"));
            pessoas.Add(new Pessoa(25, "Jefferson"));
            pessoas.Add(new Pessoa(45, "Miriam"));

            foreach (Pessoa p in pessoas)
            {
                Console.WriteLine(p.Nome + " " + p.Idade);
            }
            Console.ReadKey();
            ListaInserirItemNaPosicao();
            ListaNaoOrdenada();
            ListaOrdenadaPorNome();
            ListaOrdenadaPorIdade();
            ListaVerificarSeItemExiste();
            ListaConverterParaArray();
            ListaLocalizaPessoaMaisJovem();
            Console.ReadLine();
        }

        static void ListaNaoOrdenada()
        {
            Console.WriteLine("\nLista não ordenada");
            pessoas.ForEach(delegate (Pessoa p)
            {
                Console.WriteLine(String.Format("{0} {1}", p.Idade, p.Nome));
            });
        }

        static void ListaOrdenadaPorNome()
        {
            Console.WriteLine("\nLista Ordenada por Nome");
            pessoas.Sort(delegate (Pessoa p1, Pessoa p2)
            {
                return p1.Nome.CompareTo(p2.Nome);
            });
            pessoas.ForEach(delegate (Pessoa p)
            {
                Console.WriteLine(String.Format("{0} {1}", p.Idade, p.Nome));
            });
        }

        static void ListaOrdenadaPorIdade()
        {
            Console.WriteLine("\nLista Ordenada por Idade");
            pessoas.Sort(delegate (Pessoa p1, Pessoa p2)
            {
                return p1.Idade.CompareTo(p2.Idade);
            });
            pessoas.ForEach(delegate (Pessoa p)
            {
                Console.WriteLine(String.Format("{0} {1}", p.Idade, p.Nome));
            });
        }

        static void ListaInserirItemNaPosicao()
        {
            Console.WriteLine("\nInserindo uma pessoa na posição 1 e outra na posição 3");
            pessoas.Insert(1, new Pessoa() { Nome = "Bob Dylan", Idade = 78 });
            pessoas.Insert(3, new Pessoa() { Nome = "Jimmi Page", Idade = 81 });
        }

        static void ListaRemoverItem()
        {
            Console.WriteLine("\nRemovendo objeto Pessoa :  Nome=Macoratti, Idade=45");
            pessoas.Remove(new Pessoa() { Idade = 45 , Nome = "Macoratti" });
        }

        static void ListaVerificarSeItemExiste()
        {
            Console.WriteLine("\nExiste na Lista Pessoa com Idade igual a 78 : {0}",
                pessoas.Exists(p => p.Idade == 78));
        }

        static void ListaConverterParaArray()
        {
            Console.WriteLine("\nConvertendo a lista para um Array");
            Pessoa[] ListaArray = pessoas.ToArray();
            foreach (Pessoa p in ListaArray)
            {
                Console.WriteLine(p.Nome + " "+ p.Idade);
            }
        }

        static void ListaLocalizaPessoaMaisJovem()
        {
            List<Pessoa> jovem = pessoas.FindAll(delegate (Pessoa p) { return p.Idade < 30; });
            Console.WriteLine("\nIdade é menor que 30 : ");
            jovem.ForEach(delegate (Pessoa p)
            {
                Console.WriteLine(String.Format("{0} {1}", p.Idade, p.Nome));
            });
        }
    }
}
